

/*
Code VFO by F4ITK - 
Version 1.0 - Janvier 2023
*/

// Include the library code
#include <Wire.h>
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27,20,4); 
#include <rotary.h>
#include <EEPROM.h>

//Setup some items
#define W_CLK 8   // Pin 8 - connect to AD9850 module word load clock pin (CLK)
#define FQ_UD 9   // Pin 9 - connect to freq update pin (FQ)
#define DATA 10   // Pin 10 - connect to serial data load pin (DATA)
#define RESET 11  // Pin 11 - connect to reset pin (RST) 
#define pulseHigh(pin) {digitalWrite(pin, HIGH); digitalWrite(pin, LOW); }
Rotary r = Rotary(2,3); // sets the pins the rotary encoder uses.  Must be interrupt pins.

int_fast32_t rx=14074000; // Base (starting) frequency of VFO.  This only loads once.  To force load again see ForceFreq variable below.
int_fast32_t rx2=1; // variable to hold the updated frequency
int_fast32_t increment = 1000; // starting VFO update increment in HZ.
int_fast32_t iffreq = 10237220; // Intermedite Frequency - Amount to subtract (-) from base frequency. ********************************************
int buttonstate = 0;
int bandstate = 0;  // declaration etat bouton choix bande
int bandPosition = 17; // declaration position curseur pour affichage bande
int band = 20; // initialisation de la  valeur bande

String FTmode = "   ";

int buttonstate2 = 0;
int GoIF = 1;
String hertz = "1 Khz";
int  hertzPosition = 8;
byte ones,tens,hundreds,thousands,tenthousands,hundredthousands,millions ;  //Placeholders
String freq; // string to hold the frequency
int_fast32_t timepassed = millis(); // int to hold the arduino miilis since startup
int memstatus = 1;  // value to notify if memory is current or old. 0=old, 1=current.
int ForceFreq = 1;  // Change this to 0 after you upload and run a working sketch to activate the EEPROM memory.  YOU MUST PUT THIS BACK TO 0 AND UPLOAD THE SKETCH AGAIN AFTER STARTING FREQUENCY IS SET!

const int bouton = 4; // bouton choix USB LSB
int etatBouton; // Variable qui enregistre l'etat du bouton

void setup() {

 lcd.init(); //initialise le lcd
 lcd.backlight();
 
  pinMode(A0,INPUT); // Entrée appui bouton KY-040
  digitalWrite(A0,HIGH);

  pinMode(A1,INPUT); // Entrée  bouton  choix bande
  digitalWrite(A1,HIGH);
  
  PCICR |= (1 << PCIE2);
  PCMSK2 |= (1 << PCINT18) | (1 << PCINT19);
  sei();
  pinMode(FQ_UD, OUTPUT);
  pinMode(W_CLK, OUTPUT);
  pinMode(DATA, OUTPUT);
  pinMode(RESET, OUTPUT); 
  
  pinMode(bouton,INPUT); // bouton LSB USB en entrée
  etatBouton = HIGH; // on initialise l'etat bouton comme relaché
  
  pulseHigh(RESET);
  pulseHigh(W_CLK);
  pulseHigh(FQ_UD);  // this pulse enables serial mode on the AD9850 - Datasheet page 12.
  
  lcd.setCursor(0,1);
  lcd.print("Step:"); 
  lcd.setCursor(hertzPosition,1);    
  lcd.print(hertz); 
  lcd.setCursor(0,3);
  lcd.print("Mode:");
  lcd.setCursor(10,3);
  lcd.print("Bande:"); 
  lcd.setCursor(19,3);
  lcd.print("m"); 
       
  // Load the stored frequency  
  
  if (ForceFreq == 0) {
    freq = String(EEPROM.read(0))+String(EEPROM.read(1))+String(EEPROM.read(2))+String(EEPROM.read(3))+String(EEPROM.read(4))+String(EEPROM.read(5))+String(EEPROM.read(6));
    rx = freq.toInt();  
  
}
}
void loop() {  
   {
  //  affichage LSB  SSB  
  etatBouton = digitalRead(bouton); // lecture etat bouton 2
  if(etatBouton == HIGH) // test si le bouton est au niveau haut
  {
  lcd.setCursor(5,3);
  lcd.print("USB");   
  }
  else // test si le bouton est au niveau bas
  {
  lcd.setCursor(5,3);
  lcd.print("LSB");   

  }   
 //  affichage FT8  FT4
 if  (rx == 14074000){FTmode = "FT8";}
 else if (rx == 14080000){FTmode = "FT4";}
 else if (rx == 28074000){FTmode = "FT8";}
 else if (rx == 28180000){FTmode = "FT4";}
 else if (rx == 24915000){FTmode = "FT8";}
 else if (rx == 24919000){FTmode = "FT4";}
 else if (rx == 21074000){FTmode = "FT8";}
 else if (rx == 21140000){FTmode = "FT4";}
 else if (rx == 18100000){FTmode = "FT8";}
 else if (rx == 18104000){FTmode = "FT4";}
 else if (rx == 10136000){FTmode = "FT8";}
 else if (rx == 10140000){FTmode = "FT4";}
 else if (rx == 7074000){FTmode = "FT8";}
 else if (rx == 7047000){FTmode = "FT4";}
 else if (rx == 3575000){FTmode = "FT8";}
 else if (rx == 3573000){FTmode = "FT4";}
 else {FTmode = "   ";}
  {
  lcd.setCursor(5,2);
  lcd.print (FTmode);   
  }
 // fin affichage FT8 FT4
 
    {
  lcd.setCursor(17,3);
  lcd.print (band);   
  }
   }  
   
  // Update the display and frequency if the new Freq NEQ the old Freq  
  if (rx != rx2){   
        showFreq();
        sendFrequency(rx);
        rx2 = rx;        
      } 
        
  // Rotate through the rate of tuning as you hold down the button
  buttonstate = digitalRead(A0);
  if(buttonstate == LOW) {
        setincrement();        
    };

   // Prog  Bouton choix  bande
  bandstate = digitalRead(A1);
  if(bandstate == LOW) {
        setincrementa();        
    };
      
   // Write the frequency to memory if not stored and 2 seconds have passed since the last frequency change.
    if(memstatus == 0){   
      if(timepassed+2000 < millis()){
        storeMEM();
        }
      }  
    
 }
 
 
// Interrupt routine to catch the rotary encoder
ISR(PCINT2_vect) {
  unsigned char result = r.process();
  if (result) {    
    if (result == DIR_CW){rx=rx+increment;}
    else {rx=rx-increment;};       
      if (rx >=30000000){rx=rx2;}; // UPPER VFO LIMIT
      if (rx <=1000000){rx=rx2;}; // LOWER VFO LIMIT
  } 
}

// frequency calc from datasheet page 8 = <sys clock> * <frequency tuning word>/2^32
void sendFrequency(double frequency) {  
  if (GoIF == 1){frequency=frequency-iffreq;}; //If pin = low, subtract the IF frequency.
  int32_t freq = frequency * 4294967295/125000000;  // note 125 MHz clock on 9850.  You can make 'slight' tuning variations here by adjusting the clock frequency.
  for (int b=0; b<4; b++, freq>>=8) {
    tfr_byte(freq & 0xFF);
  }
  tfr_byte(0x000);   // Final control byte, all 0 for 9850 chip
  pulseHigh(FQ_UD);  // Done!  Should see output
}
// transfers a byte, a bit at a time, LSB first to the 9850 via serial DATA line
void tfr_byte(byte data)
{
  for (int i=0; i<8; i++, data>>=1) {
    digitalWrite(DATA, data & 0x01);
    pulseHigh(W_CLK);   //after each bit sent, CLK is pulsed high
  }
}

void setincrement(){
  if(increment == 10){increment = 50; hertz = "50 Hz"; hertzPosition=7;}
  else if (increment == 50){increment = 100;  hertz = "100 Hz"; hertzPosition=6;}
  else if (increment == 100){increment = 500; hertz="500 Hz"; hertzPosition=6;}
  else if (increment == 500){increment = 1000; hertz="1 Khz"; hertzPosition=8;}
  else if (increment == 1000){increment = 2500; hertz="2.5 Khz"; hertzPosition=6;}
  else if (increment == 2500){increment = 5000; hertz="5 Khz"; hertzPosition=8;}
  else if (increment == 5000){increment = 10000; hertz="10 Khz"; hertzPosition=7;}
  else if (increment == 10000){increment = 100000; hertz="100 Khz"; hertzPosition=6;}
  else if (increment == 100000){increment = 1000000; hertz="1 Mhz"; hertzPosition=8;}  
  else{increment = 10; hertz = "10 Hz"; hertzPosition=7;};  
   lcd.setCursor(6,1);
   lcd.print("              ");
   lcd.setCursor(hertzPosition,1); 
   lcd.print(hertz); 

   delay(250); // Adjust this delay to speed up/slow down the button menu scroll speed.
};

//  Affichage de la bande et de la Freq correspondante FT8
void setincrementa(){
 if(band == 10){band = 12; rx=24915000; bandPosition=17;}
 else if (band == 12){band = 15; rx=21074000; bandPosition=17;}  
 else if (band == 15){band = 17; rx=18100000; bandPosition=17;}  
 else if (band == 17){band = 20; rx=14074000; bandPosition=17;}  
 else if (band == 20){band = 30; rx=10136000; bandPosition=17;}  
 else if (band == 30){band = 40; rx=7074000; bandPosition=17;}  
 else if (band == 40){band = 80; rx=3573000; bandPosition=17;}  
 else if (band = 10){band = 10; rx=28074000; bandPosition=17;} 
   
 lcd.setCursor(17,3);
 lcd.print("  ");
 lcd.setCursor(bandPosition,3); 
 lcd.print(band); 
  
 delay(250); // Adjust this delay to speed up/slow down the button menu scroll speed.
};

void showFreq(){
    millions = int(rx/1000000);
    hundredthousands = ((rx/100000)%10);
    tenthousands = ((rx/10000)%10);
    thousands = ((rx/1000)%10);
    hundreds = ((rx/100)%10);
    tens = ((rx/10)%10);
    ones = ((rx/1)%10);
    lcd.setCursor(3,0);
    lcd.print("                ");
   if (millions > 9){lcd.setCursor(3,0);}
   else{lcd.setCursor(4,0);}
    lcd.print(millions);
    lcd.print(".");
    lcd.print(hundredthousands);
    lcd.print(tenthousands);
    lcd.print(thousands);
    lcd.print(".");
    lcd.print(hundreds);
    lcd.print(tens);
    lcd.print(ones);
    lcd.print(" Mhz  ");
    timepassed = millis();
    memstatus = 0; // Trigger memory write
};

void storeMEM(){
  //Write each frequency section to a EPROM slot.  Yes, it's cheating but it works!
   EEPROM.write(0,millions);
   EEPROM.write(1,hundredthousands);
   EEPROM.write(2,tenthousands);
   EEPROM.write(3,thousands);
   EEPROM.write(4,hundreds);       
   EEPROM.write(5,tens);
   EEPROM.write(6,ones);   
   memstatus = 1;  // Let program know memory has been written
};
